/* $Id: miniupnpdtypes.h,v 1.2 2008/01/27 22:24:39 nanard Exp $ */
/* MiniUPnP project
 * http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 * (c) 2006-2007 Thomas Bernard
 * This software is subject to the conditions detailed
 * in the LICENCE file provided within the distribution */
 
/*Modifications done for PCP software
 * http://pcp.....
 * (c) France Telecom
 * Created: 10/06/2011
 * Author(s):Xiaohong Deng, Zheng Tao, Lei Zhengyu
 * Description
 * Lines 50-53: store epoch and timer for server rebuilding
 * Lines 55-65: store add thread arguments
 * Lines 67-71: store delete thread arguments
 *
 */
 
#ifndef __MINIUPNPDTYPES_H__
#define __MINIUPNPDTYPES_H__

#include "config.h"
#include <netinet/in.h>

/* structure for storing lan addresses
 * with ascii representation and mask */
struct lan_addr_s {
	char str[16];	/* example: 192.168.0.1 */
	struct in_addr addr, mask;	/* ip/mask */
};

/* per redirection structure */
struct rdr {
	struct rdr *next;
	uint32_t refresh;
	uint32_t expire;
	uint32_t lifetime;
	short proto;
	unsigned short iport;
	unsigned short eport;
	char iaddr[INET_ADDRSTRLEN];
	char eaddr[INET_ADDRSTRLEN];
	int flag;
	uint32_t sleep_tm;
	char desc[];	
};

/* store epoch and timer for server rebuilding, by ZT */
struct epoch_timer {
	uint32_t lastepoch;
	uint32_t lasttime;
};

struct add_arg{
	unsigned short in_port;
	unsigned short ex_port;
	char in_ip[INET_ADDRSTRLEN];
	int proto;
	uint32_t lifetime;
	uint32_t sleep_tm;
	unsigned short *rcode;	
	char desc[100];	
	
};

struct del_arg{
	unsigned short ex_port;
	int proto;
	uint32_t sleep_tm;
};

#endif
